// common_macros.h

#pragma once

#ifndef _COMMON_MACROS_H_
#define _COMMON_MACROS_H_

//------------------------------------------------------------------------------

#define ALIGN(x,m) ((((x)+(m)-1)/(m))*(m))
#define DIV_ROUND_UP(x,m) (((x)-1)/(m)+1)

// optimization for pentium 4 (64-byte line cache)

#define ALIGN_TO_2_POW_N_OR_64(x)\
((x<=4)?4:\
(x<=8)?8:\
(x<=16)?16:\
(x<=32)?32:\
(x<=64)?64:ALIGN(x,64))

//------------------------------------------------------------------------------

#endif // __COMMON_MACROS_H__